import type { Either } from '@lokalise/node-core';
import type { QueueConsumer, MonoSchemaQueueOptions, BarrierResult, Prehandler } from '@message-queue-toolkit/core';
import type { ZodSchema } from 'zod';
import type { ExistingAMQPConsumerOptions, NewAMQPConsumerOptions } from './AbstractAmqpBaseConsumer';
import { AbstractAmqpBaseConsumer } from './AbstractAmqpBaseConsumer';
import type { AMQPConsumerDependencies } from './AbstractAmqpService';
export declare abstract class AbstractAmqpConsumerMonoSchema<MessagePayloadType extends object, ExecutionContext = undefined, PrehandlerOutput = undefined, BarrierOutput = undefined> extends AbstractAmqpBaseConsumer<MessagePayloadType, ExecutionContext, PrehandlerOutput, BarrierOutput> implements QueueConsumer {
    private readonly messageSchema;
    private readonly schemaEither;
    private readonly prehandlers;
    constructor(dependencies: AMQPConsumerDependencies, options: (NewAMQPConsumerOptions<MessagePayloadType, ExecutionContext, PrehandlerOutput> & MonoSchemaQueueOptions<MessagePayloadType>) | (ExistingAMQPConsumerOptions<MessagePayloadType, ExecutionContext, PrehandlerOutput> & MonoSchemaQueueOptions<MessagePayloadType>));
    protected processPrehandlers(message: MessagePayloadType, _messageType: string): Promise<PrehandlerOutput>;
    protected resolveNextFunction(prehandlers: Prehandler<MessagePayloadType, ExecutionContext, PrehandlerOutput>[], message: MessagePayloadType, index: number, prehandlerOutput: PrehandlerOutput, resolve: (value: PrehandlerOutput | PromiseLike<PrehandlerOutput>) => void, reject: (err: Error) => void): (prehandlerResult: import("@message-queue-toolkit/core/dist/lib/queues/HandlerContainer").PrehandlerResult) => void;
    protected resolveSchema(_message: MessagePayloadType): Either<Error, ZodSchema<MessagePayloadType, import("zod").ZodTypeDef, MessagePayloadType>>;
    /**
     * Override to implement barrier pattern
     */
    protected preHandlerBarrier(_message: MessagePayloadType): Promise<BarrierResult<BarrierOutput>>;
}
