"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbstractAmqpPublisherMultiSchema = void 0;
const core_1 = require("@message-queue-toolkit/core");
const AbstractAmqpBasePublisher_1 = require("./AbstractAmqpBasePublisher");
class AbstractAmqpPublisherMultiSchema extends AbstractAmqpBasePublisher_1.AbstractAmqpBasePublisher {
    messageSchemaContainer;
    constructor(dependencies, options) {
        super(dependencies, options);
        const messageSchemas = options.messageSchemas;
        this.messageSchemaContainer = new core_1.MessageSchemaContainer({
            messageSchemas,
            messageTypeField: options.messageTypeField,
        });
    }
    publish(message) {
        const resolveSchemaResult = this.resolveSchema(message);
        if (resolveSchemaResult.error) {
            throw resolveSchemaResult.error;
        }
        resolveSchemaResult.result.parse(message);
        if (this.logMessages) {
            // @ts-ignore
            const resolvedLogMessage = this.resolveMessageLog(message, message[this.messageTypeField]);
            this.logMessage(resolvedLogMessage);
        }
        this.sendToQueue(message);
    }
    resolveSchema(message) {
        return this.messageSchemaContainer.resolveSchema(message);
    }
}
exports.AbstractAmqpPublisherMultiSchema = AbstractAmqpPublisherMultiSchema;
//# sourceMappingURL=AbstractAmqpPublisherMultiSchema.js.map